<template lang="html">
  <v-card>
    <v-card-title>
      {{ name }}
    </v-card-title>

    <v-card-text>
      <v-row>
        <v-col cols="7">
          <v-list class="transparent">
            <v-list-item>
              <v-list-item-title>Governance Address</v-list-item-title>

              <v-list-item-subtitle>
                {{ address }}
              </v-list-item-subtitle>
            </v-list-item>
            <v-list-item>
              <v-list-item-title>Token Address</v-list-item-title>

              <v-list-item-subtitle>
                {{ tokenAddress }}
              </v-list-item-subtitle>
            </v-list-item>
          </v-list>
        </v-col>
        <v-col cols="5">
          <v-list class="transparent">
            <v-list-item>
              <v-list-item-title>Quorum Needed</v-list-item-title>

              <v-list-item-subtitle class="text-right">
                {{ quorum }} tokens
              </v-list-item-subtitle>
            </v-list-item>

            <v-list-item>
              <v-list-item-title>Proposal Threshold</v-list-item-title>

              <v-list-item-subtitle class="text-right">
                {{ proposalThreshold }} tokens
              </v-list-item-subtitle>
            </v-list-item>

            <v-list-item>
              <v-list-item-title>Voting Delay</v-list-item-title>

              <v-list-item-subtitle class="text-right">
                {{ votingDelay }} blocks
              </v-list-item-subtitle>
            </v-list-item>

            <v-list-item>
              <v-list-item-title>Voting Period</v-list-item-title>

              <v-list-item-subtitle class="text-right">
                {{ votingPeriod }} blocks
              </v-list-item-subtitle>
            </v-list-item>
          </v-list>
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <proposals />
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script>
import { getGovernor } from "@/helpers/contracts/governance.js";
import { getTokenMetadata, decimalize } from "@/helpers/contracts/token.js";
import Proposals from "./Proposals";

export default {
  name: "Governance",
  data() {
    return {
      tokenAddress: null,
      quorum: null,
      proposalThreshold: null,
      votingDelay: null,
      votingPeriod: null
    }
  },
  components: {
    Proposals
  },
  watch: {
    provider(value) {
      if (value) {
        this.providerAvailable();
      }
    }
  },
  computed: {
    name() {
      return this.$store.state.governor.name;
    },
    address() {
      return this.$store.state.governor.address;
    },
    provider() {
      return this.$store.state.provider;
    }
  },
  methods: {
    async providerAvailable() {
      const governor = getGovernor();

      const blockNumber = await this.$store.state.provider.getBlockNumber();

      const tokenMetadata = await getTokenMetadata();

      this.tokenAddress = tokenMetadata.address;
      this.quorum = decimalize((await governor.quorum(blockNumber - 1)).toString(), (await tokenMetadata.decimals()).toString(), 4);
      this.proposalThreshold = decimalize((await governor.proposalThreshold()).toString(), (await tokenMetadata.decimals()).toString(), 4);
      this.votingDelay = await governor.votingDelay();
      this.votingPeriod = await governor.votingPeriod();
    }
  }
}
</script>
